/**
 * JaDOrT: JASMINe Deployment Orchestration Tool
 * Copyright (C) 2008 Bull S.A.S.
 * Copyright (C) 2008 France Telecom R&D
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: AbsDelegateResponder.as 2376 2008-09-19 08:26:10Z alitokmen $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.jadort.client.flex.business {

    import mx.rpc.IResponder;

    /**
     * Defines an abstract class that allows to set a responder.
     * @author Florent Benoit
     */
    public class AbsDelegateResponder {

        /**
         * Responder that will handle the answer.
         */
        private var responderObject : IResponder;

        /**
         * Sets the given responder for this delegate.
         * @param responderObject the given responder
         */
        public function set responder(responderObject : IResponder) : void {
                this.responderObject = responderObject;
        }

        /**
         * @return the responder
         */
        public function get responder() : IResponder {
            return this.responderObject;
        }
    }

}
