/**
 * JaDOrT: JASMINe Deployment Orchestration Tool
 * Copyright (C) 2008 Bull S.A.S.
 * Copyright (C) 2008 France Telecom R&D
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: GetGroupsCommand.as 2376 2008-09-19 08:26:10Z alitokmen $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.jadort.client.flex.command {

    import com.adobe.cairngorm.commands.*;
    import com.adobe.cairngorm.control.*;
    import mx.collections.ArrayCollection;
    import mx.rpc.IResponder;
    import mx.rpc.events.FaultEvent;
    import mx.rpc.events.ResultEvent;
    import org.ow2.jasmine.jadort.client.flex.business.*;
    import org.ow2.jasmine.jadort.client.flex.event.*;
    import org.ow2.jasmine.jadort.client.flex.model.*;
    import org.ow2.jasmine.jadort.client.flex.vo.*;

    /**
     * This class allows to get the list of groups
     */
    public class GetGroupsCommand extends SequenceCommandWithErrorHandling implements IResponder {

        override public function execute(event : CairngormEvent) : void {

            // delegate to the GetGroupsDelegate to call the getGroups service
            var delegate : GetGroupsDelegate = JadortModelLocator.getInstance().getGroupsDelegate();
            delegate.responder = this;
            delegate.getGroups();
        }

        /**
         * Manage the result found by a delegate.
         */
        public function result(event : Object) : void {

            // ArrayCollection value is contained in the event
            var resultEvent : ResultEvent = event as ResultEvent;
            var arrayCollection : ArrayCollection = resultEvent.result as ArrayCollection;

            // Gets the Model
            var model : JadortModelLocator = JadortModelLocator.getInstance();

            // Set attributes in the model
            model.groups = arrayCollection;
            var canGoToNextStepEvent : CanGoToNextStepEvent = new CanGoToNextStepEvent();
            CairngormEventDispatcher.getInstance().dispatchEvent(canGoToNextStepEvent);

            var canGoToPreviousStepEvent : CanGoToPreviousStepEvent = new CanGoToPreviousStepEvent();
            CairngormEventDispatcher.getInstance().dispatchEvent(canGoToPreviousStepEvent);
        }
    }

}