/**
 * JaDOrT: JASMINe Deployment Orchestration Tool
 * Copyright (C) 2008 Bull S.A.S.
 * Copyright (C) 2008 France Telecom R&D
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: GetPageIndexCommand.as 2883 2008-12-11 13:35:39Z alitokmen $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.jadort.client.flex.command {

    import com.adobe.cairngorm.commands.ICommand;
    import com.adobe.cairngorm.control.CairngormEvent;
    import com.adobe.cairngorm.control.*;
    import mx.rpc.IResponder;
    import mx.rpc.events.FaultEvent;
    import mx.rpc.events.ResultEvent;
    import org.ow2.jasmine.jadort.client.flex.business.*;
    import org.ow2.jasmine.jadort.client.flex.event.*;
    import org.ow2.jasmine.jadort.client.flex.model.JadortModelLocator;
    import org.ow2.jasmine.jadort.client.flex.vo.*;

    public class GetPageIndexCommand extends SequenceCommandWithErrorHandling implements IResponder {

        /**
         * Execute the action
         */
        override public function execute(event : CairngormEvent) : void {

            // delegate to the GetPageIndexDelegate to call the getPageIndex service
            var delegate : GetPageIndexDelegate = JadortModelLocator.getInstance().getPageIndexDelegate();
            delegate.responder = this;
            delegate.getPageIndex();
        }

        /**
         * Manage the result found by a delegate.
         */
        public function result(event : Object) : void {

            // get the step number
            var resultEvent : ResultEvent = event as ResultEvent;
            var pageIndex : Number = resultEvent.result as Number;

            // Gets the Model
            var model : JadortModelLocator = JadortModelLocator.getInstance();

            // set attributes in the model, to update the IU go the page N° pageIndex
            model.setIndex(pageIndex);

            // Dispatch ProgressStateEngineStep to update the global progress bar on the top of the UI
            CairngormEventDispatcher.getInstance().dispatchEvent(new ProgressStateEngineStep("loadEngineStep",pageIndex));
        }
    }

}