/**
 * JaDOrT: JASMINe Deployment Orchestration Tool
 * Copyright (C) 2008 Bull S.A.S.
 * Copyright (C) 2008 France Telecom R&D
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: GetSelectedGroupCommand.as 2376 2008-09-19 08:26:10Z alitokmen $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.jadort.client.flex.command {

    import com.adobe.cairngorm.commands.*;
    import com.adobe.cairngorm.control.*;
    import mx.rpc.IResponder;
    import mx.rpc.events.FaultEvent;
    import mx.rpc.events.ResultEvent;
    import org.ow2.jasmine.jadort.client.flex.business.*;
    import org.ow2.jasmine.jadort.client.flex.event.*;
    import org.ow2.jasmine.jadort.client.flex.model.*;
    import org.ow2.jasmine.jadort.client.flex.vo.*;

    /**
     * This class allows to get the selected Group in the current operation
    */
    public class GetSelectedGroupCommand extends SequenceCommandWithErrorHandling implements IResponder {

        override public function execute(event : CairngormEvent) : void {

            // delegate to the GetSelectedGroupDelegate to call the getSelectedGroup service
            var delegate : GetSelectedGroupDelegate = JadortModelLocator.getInstance().getSelectedGroupDelegate();
            delegate.responder = this;
            delegate.getSelectedGroup();
        }

        /**
         * Manage the result found by a delegate.
         */
        public function result(event : Object) : void {

            // Get the selected Group
            var resultEvent : ResultEvent = event as ResultEvent;
            var selectedGroup : GroupVO = resultEvent.result as GroupVO;

            // Gets the Model
            var model : JadortModelLocator = JadortModelLocator.getInstance();

            // set selectedGroup attribute in the model with the returned selected group.
            model.selectedGroup = selectedGroup;
        }
    }

}