/**
 * JaDOrT: JASMINe Deployment Orchestration Tool
 * Copyright (C) 2008 Bull S.A.S.
 * Copyright (C) 2008 France Telecom R&D
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: IgnoreServerCommand.as 2884 2008-12-11 13:40:09Z alitokmen $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.jadort.client.flex.command {

    import com.adobe.cairngorm.commands.*;
    import mx.rpc.IResponder;
    import mx.rpc.events.FaultEvent;
    import mx.rpc.events.ResultEvent;
    import org.ow2.jasmine.jadort.client.flex.business.*;
    import org.ow2.jasmine.jadort.client.flex.event.*;
    import org.ow2.jasmine.jadort.client.flex.model.*;
    import org.ow2.jasmine.jadort.client.flex.vo.*;
    import com.adobe.cairngorm.control.*;

    /**
     * This class allows to force a server to be ignored and continues this task
     */
    public class IgnoreServerCommand extends SequenceCommandWithErrorHandling implements IResponder {

        private var server : ServerVO;

        override public function execute(event : CairngormEvent) : void {

            // cast the cairngorm event so we can get the server to be ignored
            var ignoreServerEvent : IgnoreServerEvent = event as IgnoreServerEvent;
            server = ignoreServerEvent.server;

            // delegate to the IgnoreServerDelegate to call the ignoreServer service
            var delegate : IgnoreServerDelegate = JadortModelLocator.getInstance().getIgnoreServerDelegate();
            delegate.responder = this;
            delegate.ignoreServer(server);
        }

        /**
         * Manage the result found by a delegate.
         */
        public function result(event : Object) : void {

            // Gets the Model
            var model : JadortModelLocator = JadortModelLocator.getInstance();

            // after executing the abortServer command we dispatch the ServerProgressListEvent Event to get the serverProgressList
            // data to refresh the UI.
            nextEvent = new GetServerProgressListEvent();
            executeNextCommand();
        }
    }

}