/**
 * JaDOrT: JASMINe Deployment Orchestration Tool
 * Copyright (C) 2008 Bull S.A.S.
 * Copyright (C) 2008 France Telecom R&D
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: LoadTopologyCommand.as 2883 2008-12-11 13:35:39Z alitokmen $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.jadort.client.flex.command {

    import com.adobe.cairngorm.commands.*;
    import com.adobe.cairngorm.control.*;
    import mx.collections.ArrayCollection;
    import mx.rpc.IResponder;
    import mx.rpc.events.FaultEvent;
    import mx.rpc.events.ResultEvent;
    import mx.controls.Alert;
    import org.ow2.jasmine.jadort.client.flex.business.*;
    import org.ow2.jasmine.jadort.client.flex.event.*;
    import org.ow2.jasmine.jadort.client.flex.model.*;
    import org.ow2.jasmine.jadort.client.flex.vo.*;

    /**
     * This class Loads the topology.
     */
    public class LoadTopologyCommand extends SequenceCommandWithErrorHandling implements IResponder {

        override public function execute(event : CairngormEvent) : void {

            // cast the cairngorm event so we can get the topology File
            var loadTopologyEvent : LoadTopologyEvent = event as LoadTopologyEvent;

            // delegate to the LoadTopologyDelegate to call the loadTopology service
            var delegate : LoadTopologyDelegate = JadortModelLocator.getInstance().getLoadTopologyDelegate();
            delegate.responder = this;
            delegate.loadTopology(loadTopologyEvent.exmlTopologyFile);
        }

        /**
         * Manage the result found by a delegate.
         */
        public function result(event : Object) : void {

            Alert.show("Topology has been loaded succesufully");

            // Dispatch CanGoToNextStepEvent to test if the we can go next
            // to update the UI of application selection (make the button "next" enable)
                var canGoToNextStepEvent : CanGoToNextStepEvent = new CanGoToNextStepEvent();
            CairngormEventDispatcher.getInstance().dispatchEvent(canGoToNextStepEvent);
        }
    }

}
