/**
 * JaDOrT: JASMINe Deployment Orchestration Tool
 * Copyright (C) 2008 Bull S.A.S.
 * Copyright (C) 2008 France Telecom R&D
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: JadortControl.as 2889 2008-12-15 12:26:23Z alitokmen $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.jadort.client.flex.control
{
    import com.adobe.cairngorm.control.*;
    import org.ow2.jasmine.jadort.client.flex.command.*;
    import org.ow2.jasmine.jadort.client.flex.event.*;

    public class JadortControl extends FrontController
    {
        public function JadortControl()
        {
            addCommand(GetServerProgressListEvent.EVENT_GET_SERVER_PROGRESS_LIST, GetServerProgressListCommand);
            addCommand(AbortServerEvent.EVENT_ABORT_SERVER, AbortServerCommand);
            addCommand(RestartServerEvent.EVENT_RESTART_SERVER, RestartServerCommand);
            addCommand(IgnoreServerEvent.EVENT_FORCE_SERVER, IgnoreServerCommand);
            addCommand(GetGroupsEvent.EVENT_GET_GROUPS, GetGroupsCommand);
            addCommand(CreateApplicationEvent.EVENT_CREATE_APPLICATION, CreateApplicationCommand);
            addCommand(GetApplicationEvent.EVENT_GET_APPLICATION, GetApplicationCommand);
            addCommand(CheckServerEvent.EVENT_CHECK_SERVER, CheckServerCommand);
            addCommand(CheckWorkerEvent.EVENT_CHECK_WORKER, CheckWorkerCommand);
            addCommand(GetPageIndexEvent.EVENT_GET_PAGE_INDEX, GetPageIndexCommand);
            addCommand(NextEvent.EVENT_NEXT, NextCommand);
            addCommand(PreviousEvent.EVENT_PREVIOUS, PreviousCommand);
            addCommand(LoadTopologyEvent.EVENT_LOAD_TOPOLOGY, LoadTopologyCommand);
            addCommand(SelectGroupEvent.EVENT_SELECT_GROUP, SelectGroupCommand);
            addCommand(CanGoToNextStepEvent.EVENT_CAN_GOTO_NEXT_STEP, CanGoToNextStepCommand);
            addCommand(CanGoToPreviousStepEvent.EVENT_CAN_GOTO_PREVIOUS_STEP, CanGoToPreviousStepCommand);
            addCommand(GetSelectedGroupEvent.EVENT_GET_SELECTED_GROUP, GetSelectedGroupCommand);
            addCommand(SelectOperationEvent.EVENT_SELECT_OPERATION, SelectOperationCommand);
            addCommand(CreateNewOperationEvent.EVENT_CREATE_NEW_OPERATION, CreateNewOperationCommand);
            addCommand(GetOperationsListEvent.EVENT_GET_OPERATIONS_LIST, GetOperationsListCommand);
            addCommand(DeleteOperationEvent.EVENT_DELETE_OPERATION, DeleteOperationCommand);
            addCommand(InitializeEvent.EVENT_INITIALIZE, InitializeCommand);
            addCommand(GetTotalActiveSessionsEvent.EVENT_GET_TOTAL_ACTIVE_SESSIONS, GetTotalActiveSessionsCommand);
            addCommand(GetWorkerProgressListEvent.EVENT_GET_WORKERS_PROGRESS, GetWorkerProgressListCommand);
            addCommand(SelectServersEvent.EVENT_SELECT_SERVERS, SelectServersCommand);
            addCommand(GetServersEvent.EVENT_GET_SERVERS, GetServersCommand);
            addCommand(AbortWorkerEvent.EVENT_ABORT_WORKER, AbortWorkerCommand);
            addCommand(RestartWorkerEvent.EVENT_RESTART_WORKER, RestartWorkerCommand);
            addCommand(IgnoreWorkerEvent.EVENT_FORCE_WORKER, IgnoreWorkerCommand);
        }
    }
}
