/**
 * JaDOrT: JASMINe Deployment Orchestration Tool
 * Copyright (C) 2008 Bull S.A.S.
 * Copyright (C) 2008 France Telecom R&D
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: SelectGroupEvent.as 2373 2008-09-18 16:06:27Z alitokmen $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.jadort.client.flex.event {

    import org.ow2.jasmine.jadort.client.flex.vo.*;


    public class SelectGroupEvent extends JadortEvent {

        /**
         * Name of the Event.
         */
        public static const EVENT_SELECT_GROUP : String = "selectGroup";

        // the selected group
        private var group : GroupVO;
        
        // the opetration type
        private var operationType : String;

        /**
         * Default constructor.
         */
        public function SelectGroupEvent(group : GroupVO, operationType : String) {
            super(EVENT_SELECT_GROUP);
            this.group = group;
            this.operationType = operationType;
        }

        public function get eGroup() : GroupVO {
            return group;
        }
        
        public function get eOperationType() : String {
            return operationType;
        }
    }

}