/**
 * JaDOrT: JASMINe Deployment Orchestration Tool
 * Copyright (C) 2008 Bull S.A.S.
 * Copyright (C) 2008 France Telecom R&D
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: SelectGroupActionOperationRenderClass.as 2402 2008-09-19 17:33:33Z alitokmen $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.jadort.client.flex.view {

    import flash.events.*;
    import mx.containers.TitleWindow;
    import mx.containers.VBox;
    import mx.controls.*;
    import mx.controls.dataGridClasses.DataGridListData;
    import mx.controls.listClasses.BaseListData;
    import mx.events.*;
    import mx.managers.*;
    import org.ow2.jasmine.jadort.client.flex.event.SelectGroupEvent;
    import org.ow2.jasmine.jadort.client.flex.model.JadortModelLocator;
    import org.ow2.jasmine.jadort.client.flex.vo.*;
    import com.adobe.cairngorm.control.CairngormEventDispatcher;
    import mx.collections.ArrayCollection;

    public class SelectGroupActionOperationRenderClass extends VBox {

        public var applicationMigrationButton : Button;
    
        public var maintenanceButton : Button;

        private var _listData : DataGridListData;

        private var messageWindow : TitleWindow;

        [Bindable]
        private var message : String;

        [Bindable]
        public var group : GroupVO;


        [Bindable]
        public var model : JadortModelLocator = JadortModelLocator.getInstance();

        public function showMessage() : void {
            messageWindow = TitleWindow(PopUpManager.createPopUp(this,ErrorLogPopUp,true));
         (messageWindow as ErrorLogPopUp).messageError.text = this.message;
            messageWindow.addEventListener(CloseEvent.CLOSE,onClose);
            messageWindow.showCloseButton = true;
            PopUpManager.centerPopUp(messageWindow);
        }

        private function onClose(e : CloseEvent) : void {
            PopUpManager.removePopUp(messageWindow);
            }

        public function set listData(value : BaseListData) : void {
            _listData = DataGridListData(value);
        }

        public function get listData() : BaseListData {
            return _listData;
        }

        // this function dispatch the SelectGroupEvent to select a group
        public function migrateApplication(event : Event) : void {
            model.selectedServers = super.data.servers;
            model.selectedGroup = super.data as GroupVO;
            var selectGroupEvent : SelectGroupEvent = new SelectGroupEvent(model.selectedGroup, "MIGRATE");
            CairngormEventDispatcher.getInstance().dispatchEvent(selectGroupEvent);
        }

        public function maintain(event : Event) : void {
            model.selectedGroup = super.data as GroupVO;
            model.selectedServers = new ArrayCollection();
            model.servers = super.data.servers;
            var selectGroupEvent : SelectGroupEvent = new SelectGroupEvent(model.selectedGroup, "MAINTAIN");
            CairngormEventDispatcher.getInstance().dispatchEvent(selectGroupEvent);
        }

    }

}